diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorColor.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorColor.java
new file mode 100644
index 000000000..6e297d8c9
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorColor.java
@@ -0,0 +1,26 @@
+package net.minecraft.client.render.tessellator;
+
+import net.minecraft.core.util.helper.Color;
+
+public interface TessellatorColor extends Tessellator {
+    default void setColorOpaque3f(float r, float g, float b) {
+        setColor1i(Color.floatToIntARGB(1f, r, g, b));
+    }
+    default void setColor4f(float r, float g, float b, float a) {
+        setColor1i(Color.floatToIntARGB(a, r, g, b));
+    }
+    default void setColorOpaque3i(int r, int g, int b) {
+        setColor1i(Color.intToIntARGB(255, r, g, b));
+    }
+    default void setColor4i(int r, int g, int b, int a) {
+        setColor1i(Color.intToIntARGB(a, r, g, b));
+    }
+    default void setColorOpaque1i(int rgb) {
+        setColor1i(rgb | 0xFF000000);
+    }
+    default void setColor2i(int rgb, int a) {
+        setColor1i((rgb & 0xFFFFFF) | (a << 24) & 0xFF000000);
+    }
+    void setColor1i(int argb);
+    void lockColor();
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
new file mode 100644
index 000000000..f2a5d17ed
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
@@ -0,0 +1,149 @@
+package net.minecraft.client.render.tessellator;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
+
+import java.nio.ByteBuffer;
+import java.util.Arrays;
+
+public class TessellatorFont {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private boolean drawing = false;
+
+    private int color;
+
+    private final int vao;
+    private final int vbo;
+
+    private final @NotNull String name;
+    private ByteBuffer data;
+    private int vertexCount;
+
+    public TessellatorFont(@NotNull String name, int initialCapacity) {
+        this.name = name;
+        this.data = BufferUtils.createByteBuffer(initialCapacity);
+
+        this.vao = GL41.glGenVertexArrays();
+        this.vbo = GL41.glGenBuffers();
+
+        GL41.glBindVertexArray(this.vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+
+        int vertSize = 9 * Float.BYTES + 4;
+        int offset = 0;
+        GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // Pos XY
+        GL41.glVertexAttribPointer(1, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // Width Height
+        GL41.glVertexAttribPointer(2, 1, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 1; // Shift
+        GL41.glVertexAttribPointer(3, 4, GL41.GL_UNSIGNED_BYTE, true,   vertSize, offset); offset += 4;               // Color
+        GL41.glVertexAttribPointer(4, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // UV
+        GL41.glVertexAttribPointer(5, 2, GL41.GL_FLOAT, false,          vertSize, offset); offset += Float.BYTES * 2; // UV Sizes
+        GL41.glVertexAttrib2f(6, 15.5f/16f, 15.5f/16f);
+
+        GL41.glEnableVertexAttribArray(0);
+        GL41.glEnableVertexAttribArray(1);
+        GL41.glEnableVertexAttribArray(2);
+        GL41.glEnableVertexAttribArray(3);
+        GL41.glEnableVertexAttribArray(4);
+        GL41.glEnableVertexAttribArray(5);
+        GL41.glBindVertexArray(0);
+    }
+
+    public void startDrawing() {
+        if (this.drawing) {
+            this.drawing = false;
+            throw new IllegalStateException(this.name + " already drawing!");
+        }
+
+        this.drawing = true;
+        this.vertexCount = 0;
+        this.data.clear();
+
+        setColor1i(0xFFFFFFFF);
+    }
+
+
+    public void addChar(double x, double y, double width, double height, double shift, double u, double v, double uSize, double vSize) {
+        checkIsDrawing();
+        checkCanFit(64);
+
+        this.data.putFloat((float) x);
+        this.data.putFloat((float) y);
+
+        this.data.putFloat((float) width);
+        this.data.putFloat((float) height);
+
+        this.data.putFloat((float) shift);
+
+        this.data.putInt(this.color);
+
+//        this.data.put((byte) (u * 255));
+//        this.data.put((byte) (v * 255));
+//        this.data.put((byte) (uSize * 255));
+//        this.data.put((byte) (vSize * 255));
+
+        this.data.putFloat((float) (u));
+        this.data.putFloat((float) (v));
+        this.data.putFloat((float) (uSize));
+        this.data.putFloat((float) (vSize));
+
+        this.vertexCount++;
+    }
+
+    public void draw() {
+        if(!this.drawing) {
+            throw new IllegalStateException(this.name + " not drawing!");
+        }
+        this.drawing = false;
+
+        if (this.vertexCount == 0) return;
+
+        GL41.glBindVertexArray(this.vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+
+        GL41.glVertexAttrib2f(6, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
+
+        GL41.glDrawArrays(DrawMode.POINTS.cap, 0, this.vertexCount);
+        GL41.glBindVertexArray(0);
+    }
+
+    public void setColor1i(int argb) {
+        checkIsDrawing();
+
+        int a = (argb >> 24) & 0xFF;
+        int r = (argb >> 16) & 0xFF;
+        int g = (argb >> 8) & 0xFF;
+        int b = argb & 0xFF;
+
+        this.color = a << 24 | b << 16 | g << 8 | r;
+    }
+
+    public void setColor2i(int rgb, int a) {
+        setColor1i((rgb & 0xFFFFFF) | (a << 24) & 0xFF000000);
+    }
+
+
+    public void checkIsDrawing() {
+        if (!this.drawing) {
+            throw new IllegalStateException(this.name + " not drawing!");
+        }
+    }
+
+    public void checkCanFit(int size) {
+        if(this.data.capacity() < this.data.position() + size) {
+            int newSize = this.data.capacity() * 2;
+
+            LOGGER.info("Expanding {} Buffer ({} -> {})", this.name, this.data.capacity(), newSize);
+
+            ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
+            this.data.flip();
+            newBuffer.put(this.data);
+            this.data = newBuffer;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
new file mode 100644
index 000000000..1f51a346f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
@@ -0,0 +1,6 @@
+package net.minecraft.client.render.tessellator;
+
+public interface TessellatorGeneral extends TessellatorColor, TessellatorTextured, TessellatorLightmap, TessellatorNormal, TessellatorTerrain, Tessellator {
+
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLightmap.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLightmap.java
new file mode 100644
index 000000000..10f74ccaa
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLightmap.java
@@ -0,0 +1,10 @@
+package net.minecraft.client.render.tessellator;
+
+import net.minecraft.client.render.LightmapHelper;
+
+public interface TessellatorLightmap extends Tessellator{
+    void setLightmapCoord1i(int lightmapCoord);
+    default void setLightmapCoord2i(int blockLight, int skyLight) {
+        setLightmapCoord1i(LightmapHelper.getLightmapCoord(skyLight, blockLight));
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorNormal.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorNormal.java
new file mode 100644
index 000000000..809c5500b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorNormal.java
@@ -0,0 +1,5 @@
+package net.minecraft.client.render.tessellator;
+
+public interface TessellatorNormal extends Tessellator{
+    void setNormal(float x, float y, float z);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/ParticleTessellator.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticle.java
similarity index 57%
rename from game/client/src/main/java/net/minecraft/client/render/tessellator/ParticleTessellator.java
rename to game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticle.java
index 5791da58f..47c24ffe1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/ParticleTessellator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticle.java
@@ -3,16 +3,16 @@ package net.minecraft.client.render.tessellator;
 import net.minecraft.client.render.camera.ICamera;
 import org.jetbrains.annotations.NotNull;
 
-public interface ParticleTessellator {
+public interface TessellatorParticle {
 
     void startDrawingParticles();
-    void setLightmapCoord(int lightmapCoord);
-    void setColorOpaque_F(float r, float g, float b);
-    void setColorRGBA_F(float r, float g, float b, float a);
-    void setColorOpaque(int r, int g, int b);
-    void setColorRGBA(int r, int g, int b, int a);
-    void setColorOpaque_I(int rgb);
-    void setColorRGBA_I(int rgb, int a);
+    void setLightmapCoord1i(int lightmapCoord);
+    void setColorOpaque3f(float r, float g, float b);
+    void setColor4f(float r, float g, float b, float a);
+    void setColorOpaque3i(int r, int g, int b);
+    void setColor4i(int r, int g, int b, int a);
+    void setColorOpaque1i(int rgb);
+    void setColor2i(int rgb, int a);
     void setupParticleValues(@NotNull ICamera camera, float partialTick);
     void addParticle(double x, double y, double z, float scale, double u, double v, double uSize, double vSize);
     void drawParticles();
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
new file mode 100644
index 000000000..86b3f3c11
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
@@ -0,0 +1,177 @@
+package net.minecraft.client.render.tessellator;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
+
+import java.nio.ByteBuffer;
+import java.nio.ByteOrder;
+
+public class TessellatorParticleShader implements TessellatorParticle {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private boolean drawing = false;
+    private ByteBuffer buffer;
+
+    private int count = 0;
+    private final int vao;
+    private final int vbo;
+
+    private int color;
+    private int lightmapCoord;
+
+    private double offsetX;
+    private double offsetY;
+    private double offsetZ;
+
+    public TessellatorParticleShader(int size) {
+        this.buffer = Buffer.createBuffer(size);
+        this.vao = GL41.glGenVertexArrays();
+        this.vbo = GL41.glGenBuffers();
+
+        GL41.glBindVertexArray(this.vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+
+        int offset = 0;
+        int vertexSize = 38;
+        GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
+        GL41.glVertexAttribPointer(1, 1, GL41.GL_FLOAT, false, vertexSize, offset); offset += Float.BYTES;        // Scale
+        GL41.glVertexAttribPointer(2, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset);  offset += 4;          // Color
+        GL41.glVertexAttribPointer(3, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
+        GL41.glVertexAttribPointer(4, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UVSizes
+        GL41.glVertexAttribPointer(5, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;           // Lightmap
+
+        GL41.glEnableVertexAttribArray(0);
+        GL41.glEnableVertexAttribArray(1);
+        GL41.glEnableVertexAttribArray(2);
+        GL41.glEnableVertexAttribArray(3);
+        GL41.glEnableVertexAttribArray(4);
+        GL41.glEnableVertexAttribArray(5);
+
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
+        GL41.glBindVertexArray(0);
+    }
+
+    public void startDrawingParticles() {
+        if(this.drawing) {
+            throw new IllegalStateException("Already drawing!");
+        }
+        this.drawing = true;
+        this.color = 0xFFFFFFFF;
+        this.lightmapCoord = LightmapHelper.getLightmapCoord(15, 15);
+        this.count = 0;
+        this.buffer.clear();
+    }
+
+    public void setLightmapCoord1i(int lightmapCoord) {
+        checkIsDrawing();
+
+        this.lightmapCoord = lightmapCoord;
+    }
+
+    public void addParticle(double x, double y, double z, float scale, double u, double v, double uSize, double vSize) {
+        checkIsDrawing();
+        if(this.buffer.capacity() < this.buffer.position() + 64) {
+            int newSize = this.buffer.capacity() * 2;
+
+            LOGGER.info("Expanding Particle Tessellator Buffer ({} -> {})", this.buffer.capacity(), newSize);
+
+            ByteBuffer newBuffer = ByteBuffer.allocateDirect(newSize).order(ByteOrder.nativeOrder());
+            this.buffer.flip();
+            newBuffer.put(this.buffer);
+            this.buffer = newBuffer;
+        }
+
+        this.buffer.putFloat((float) (x + this.offsetX)).putFloat((float)(y + this.offsetY)).putFloat((float)(z + this.offsetZ)).putFloat(scale);
+        this.buffer.putInt(this.color);
+        this.buffer.putFloat((float) u).putFloat((float) v);
+        this.buffer.putFloat((float) uSize).putFloat((float) vSize);
+        this.buffer.put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmapCoord) << 4) + 7)).put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmapCoord) << 4) + 7));
+
+
+        this.count++;
+    }
+
+    public void drawParticles() {
+        checkIsDrawing();
+        this.drawing = false;
+
+        if (this.count == 0) return;
+
+        GL41.glBindVertexArray(this.vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.buffer.flip(), GL41.GL_STREAM_DRAW);
+
+        GLRenderer.render(this.vao, this.vbo, 0, this.count, DrawMode.POINTS);
+    }
+
+    public void checkIsDrawing() {
+        if(!this.drawing) {
+            throw new IllegalStateException("Not drawing!");
+        }
+    }
+
+    public void setTranslation(double x, double y, double z) {
+        this.offsetX = x;
+        this.offsetY = y;
+        this.offsetZ = z;
+    }
+    public void offsetTranslation(double x, double y, double z) {
+        this.offsetX += x;
+        this.offsetY += y;
+        this.offsetZ += z;
+    }
+
+    @Override
+    public void setColorOpaque3i(int r, int g, int b) {
+        this.setColor4i(r, g, b, 255);
+    }
+
+    @Override
+    public void setColorOpaque3f(float r, float g, float b) {
+        this.setColorOpaque3i((int) (r * 255.0F), (int) (g * 255.0F), (int) (b * 255.0F));
+    }
+
+    @Override
+    public void setColorOpaque1i(int rgb) {
+        int r = rgb >> 16 & 255;
+        int g = rgb >> 8 & 255;
+        int b = rgb & 255;
+        this.setColorOpaque3i(r, g, b);
+    }
+
+    @Override
+    public void setColor4f(float r, float g, float b, float a) {
+        this.setColor4i((int) (r * 255.0F), (int) (g * 255.0F), (int) (b * 255.0F), (int) (a * 255.0F));
+    }
+
+    @Override
+    public void setColor2i(int rgb, int a) {
+        int r = rgb >> 16 & 255;
+        int g = rgb >> 8 & 255;
+        int b = rgb & 255;
+        this.setColor4i(r, g, b, a);
+    }
+
+    @Override
+    public void setupParticleValues(@NotNull ICamera camera, float partialTick) {
+        // Do nothing shader handles everything already
+    }
+
+    @Override
+    public void setColor4i(int r, int g, int b, int a) {
+        checkIsDrawing();
+        r = MathHelper.clamp(r, 0, 255);
+        g = MathHelper.clamp(g, 0, 255);
+        b = MathHelper.clamp(b, 0, 255);
+        a = MathHelper.clamp(a, 0, 255);
+
+        this.color = a << 24 | b << 16 | g << 8 | r;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
new file mode 100644
index 000000000..82a565cf2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
@@ -0,0 +1,253 @@
+package net.minecraft.client.render.tessellator;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
+
+public class TessellatorShader extends TessellatorBase implements TessellatorGeneral{
+
+    private boolean lockColor = false;
+    private boolean quadEmulation = false;
+
+    private boolean enableColor;
+    private boolean enableTexture;
+    private boolean enableLightmap;
+    private boolean enableNormal;
+
+    private int color;
+    private int lightmap;
+
+    private float texU;
+    private float texV;
+
+    private byte normalX;
+    private byte normalY;
+    private byte normalZ;
+
+    public final int vao;
+    public final int vbo;
+
+    private int quadVertCount = 0;
+
+    public TessellatorShader(@NotNull String name, int initialCapacity) {
+        super(name, initialCapacity);
+        this.vao = GL41.glGenVertexArrays();
+        this.vbo = GL41.glGenBuffers();
+    }
+
+    @Override
+    public void startDrawing(@NotNull DrawMode drawMode) {
+        super.startDrawing(drawMode);
+
+        this.lockColor = false;
+        this.enableColor = false;
+        this.enableTexture = false;
+        this.enableLightmap = false;
+        this.enableNormal = false;
+
+        this.quadEmulation = drawMode == DrawMode.QUADS && Tessellator.QUAD_EMULATION;
+        if (this.quadEmulation) {
+            this.drawMode = DrawMode.TRIANGLES;
+        }
+        this.quadVertCount = 0;
+    }
+
+    @Override
+    public void addVertex(double x, double y, double z) {
+        checkIsDrawing();
+        checkCanFit(64);
+
+        this.data.putFloat((float) (this.offsetX + x));
+        this.data.putFloat((float) (this.offsetY + y));
+        this.data.putFloat((float) (this.offsetZ + z));
+
+        if(this.enableColor) {
+            this.data.putInt(this.color);
+        }
+
+        if(this.enableTexture) {
+            this.data.putFloat(this.texU);
+            this.data.putFloat(this.texV);
+        }
+
+        if(this.enableLightmap) {
+            this.data.put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmap) << 4) + 7));
+            this.data.put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmap) << 4) + 7));
+        }
+
+        if(this.enableNormal) {
+            this.data.put(this.normalX);
+            this.data.put(this.normalY);
+            this.data.put(this.normalZ);
+        }
+        this.vertexCount++;
+
+        if (this.quadEmulation && this.quadVertCount % 4 == 2) {
+            int vertSize = getVertexSize();
+
+            checkCanFit(128);
+            this.data.put(this.data.position(), this.data, this.data.position() - vertSize * 3, vertSize);
+            this.data.put(this.data.position() + vertSize, this.data, this.data.position() - vertSize, vertSize);
+            this.data.position(this.data.position() + vertSize * 2);
+            this.vertexCount += 2;
+        }
+
+        this.quadVertCount++;
+    }
+
+    @Override
+    public void lockColor() {
+        checkIsDrawing();
+        this.lockColor = true;
+    }
+
+    @Override
+    public void setColor1i(int argb) {
+        checkIsDrawing();
+        if (this.lockColor) {
+            return;
+        }
+        if (!this.enableColor) {
+            if (this.vertexCount > 0) {
+                this.drawing = false;
+                throw new IllegalStateException(this.name + " color is disabled!");
+            }
+            this.enableColor = true;
+        }
+
+        int a = (argb >> 24) & 0xFF;
+        int r = (argb >> 16) & 0xFF;
+        int g = (argb >> 8) & 0xFF;
+        int b = argb & 0xFF;
+
+        this.color = a << 24 | b << 16 | g << 8 | r;
+    }
+
+    @Override
+    public void setTextureUV(double u, double v) {
+        checkIsDrawing();
+        if (!this.enableTexture) {
+            if (this.vertexCount > 0) {
+                this.drawing = false;
+                throw new IllegalStateException(this.name + " texture is disabled!");
+            }
+            this.enableTexture = true;
+        }
+
+        this.texU = (float) u;
+        this.texV = (float) v;
+    }
+
+    @Override
+    public void setLightmapCoord1i(int lightmapCoord) {
+        checkIsDrawing();
+        if (!this.enableLightmap) {
+            if (this.vertexCount > 0) {
+                this.drawing = false;
+                throw new IllegalStateException(this.name + " lightmap is disabled!");
+            }
+            this.enableLightmap = true;
+        }
+
+        this.lightmap = lightmapCoord;
+    }
+
+    @Override
+    public void setNormal(float x, float y, float z) {
+        checkIsDrawing();
+        if (!this.enableNormal) {
+            if (this.vertexCount > 0) {
+                this.drawing = false;
+                throw new IllegalStateException(this.name + " normal is disabled!");
+            }
+            this.enableNormal = true;
+        }
+
+        this.normalX = (byte) (x * 127.0f);
+        this.normalY = (byte) (y * 127.0f);
+        this.normalZ = (byte) (z * 127.0f);
+    }
+
+    @Override
+    public void draw() {
+        checkIsDrawing();
+        this.drawing = false;
+
+        if (this.vertexCount == 0) return;
+
+        enableVertexAttribs(this.vao, this.vbo);
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
+        GLRenderer.render(this.vao, this.vbo, 0, this.vertexCount, this.drawMode);
+    }
+
+    @Override
+    public @NotNull RenderBuffer record(int vao, int vbo) {
+        checkIsDrawing();
+        this.drawing = false;
+
+        enableVertexAttribs(vao, vbo);
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STATIC_DRAW);
+        GL41.glBindVertexArray(0);
+        return new RenderBuffer(vao, vbo, 0, this.vertexCount, this.drawMode);
+    }
+
+    protected int getVertexSize() {
+        int size = Float.BYTES * 3;
+        if(this.enableColor) {
+            size += 4;
+        }
+        if(this.enableTexture) {
+            size += Float.BYTES * 2;
+        }
+        if(this.enableNormal) {
+            size += 3;
+        }
+        if(this.enableLightmap) {
+            size += 2;
+        }
+
+        return size;
+    }
+
+    protected void enableVertexAttribs(int vao, int vbo) {
+        GL41.glBindVertexArray(vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+        int vertexSize = getVertexSize();
+        int offset = 0;
+        GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
+        GL41.glEnableVertexAttribArray(0);
+        if (this.enableColor) {
+            GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 4;    // Color
+            GL41.glEnableVertexAttribArray(1);
+        } else {
+            GL41.glDisableVertexAttribArray(1);
+            GL41.glVertexAttrib4f(1, 1f, 1f, 1f, 1f);
+        }
+
+        if (this.enableTexture) {
+            GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
+            GL41.glEnableVertexAttribArray(2);
+        } else {
+            GL41.glDisableVertexAttribArray(2);
+        }
+
+        if (this.enableLightmap) {
+            GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;    // Lightmap
+            GL41.glEnableVertexAttribArray(3);
+        } else {
+            GL41.glDisableVertexAttribArray(3);
+            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+        }
+
+        if (this.enableNormal) {
+            GL41.glVertexAttribPointer(4, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3;    // Normal
+            GL41.glEnableVertexAttribArray(4);
+        } else {
+            GL41.glDisableVertexAttribArray(4);
+            GL41.glVertexAttrib3f(4, 0, -1, 0);
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrain.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrain.java
new file mode 100644
index 000000000..0e5bc837b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrain.java
@@ -0,0 +1,4 @@
+package net.minecraft.client.render.tessellator;
+
+public interface TessellatorTerrain extends TessellatorColor, TessellatorTextured, TessellatorLightmap {
+}
